
#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include <string.h>

#ifndef MAX_PATH
 #define MAX_PATH 512
#endif

#include "HTMLWriter.h"

HTMLWriter::HTMLWriter(char *szFilename)
{
	Open(szFilename);
}
HTMLWriter::~HTMLWriter()
{
	Close();
}

void HTMLWriter::Output(char *s)
{
	if (s)
		fputs(s,m_h);
}

void HTMLWriter::Output(char *s, long nLength)
{
	if (s && nLength>0)
		fwrite(s,1,nLength,m_h);
}

void HTMLWriter::Output(CString &s)
{
	if (!s.IsEmpty())
		Output(s.GetBuffer(0));
}

void HTMLWriter::Output(CString &style, CString &s1, CString &s2, CString &s3, CString &s4, CString &s5, CString &s6, BOOL bNewTable)
{
/* of the form
 <tr> 
    <td><a href="javascript:showhelper('_NbTotalElements')" title="Help on Nb total elements" class="link">?</a></td>
    <td class="m1">&nbsp;</td>
    <td class="m1">Nb total elements</td>
    <td class="m1">258</td>
    <td class="m1">&nbsp;</td>
  </tr>
*/
	CString sWidth1,sWidth2,sWidth3,sWidth4;
	if (bNewTable)
	{
		sWidth1="width=\"9%%\" ";
		sWidth2="width=\"41%%\" ";
		sWidth3="width=\"18%%\" ";
		sWidth4="width=\"32%%\" ";
	}

	CString s;

	s.Format("<tr><td><a href=\"javascript:showhelper('%s')\" title=\"%s\" class=\"link\">?</a></td><td %sclass=\"%s\">%s</td><td %sclass=\"%s\">%s</td><td %sclass=\"%s\">%s</td><td %sclass=\"%s\">%s</td></tr>",
		s1,
		s2,
		sWidth1,style,s3,
		sWidth2,style,s4,
		sWidth3,style,s5,
		sWidth4,style,s6);

	Output(s);
}

void HTMLWriter::OutputThisFile(char *szInputFilename) // extract content of this file and output it
{
	if (!szInputFilename || !m_h)
		return;

	FILE *fp=fopen(szInputFilename,"r"); // ASCII mode, read-only
	if (fp)
	{
		char szBuf[HTMLBUFSIZE+1];

		int nActualLength;
		do
		{
			nActualLength = fread(szBuf, 1, HTMLBUFSIZE, fp);
			szBuf[nActualLength]=0; // force EOL

			// output
			fputs(szBuf,m_h);
		}
		while (nActualLength>0);

		fclose(fp);
	}
}


void HTMLWriter::Open(char *szFilename)
{
	if (!szFilename)
		return; // avoid stupid problems

	m_h = fopen(szFilename,"w+"); // create it if does not exist yet
}

void HTMLWriter::Close()
{
	fflush(m_h);
	fclose(m_h);
}

