

#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include <string.h>

#ifndef MAX_PATH
 #define MAX_PATH 512
#endif


#include "CString.h"
#include "HtmlParser.h"


// perform a variety of transforms including :
// - style attribute of <FONT> tag switched to 2, if any
// - added quotes where they lack
// - href attribute of <A> tag repurposed to reach the right DNS
void HTMLParser::UpdateTagsAttributes(char *szHtml, char *szBaseUrl)
{
	UINT nFirst; // where there is a '<' sign
	UINT nEnd; // where there is a '>' sign
	// first tag only
	bool bTagDesired; // tells that next coming tag should (or not) be output

	UINT nStart = 0; // starts with the first char in szHtml (!!)

	char szOutputHtml[2048]="\0"; // output string (WARNING :limited size)

	UINT nNbMultipleSpaces;

	while ( GetNextTag(szHtml,nStart,/*out*/nFirst,/*out*/nEnd,/*out*/nNbMultipleSpaces) )
	{
		bTagDesired = true; // default value before we decide

		if (nFirst>nStart) // output non-tag stuff
		{
			strncat(szOutputHtml,szHtml+nStart,nFirst-nStart);
			strcat(szOutputHtml,"\0");
		}

		UINT nBeginAttrName, nEndAttrName;
		UINT nBeginAttrValue, nEndAttrValue;
		UINT nBegin = nFirst+1;

		bool bSeenTag = false; // tells us whether the current attribute is the first in the pipeline or not
		bool bSeenTargetOnAnchor = false; // tells us whether we are processing the "target" attribute of an anchor

		char szTagName[MAX_PATH]="\0";

		while (GetNextAttribute(szHtml,nBegin,
					nFirst,nEnd,
					nBeginAttrName,nEndAttrName,
					nBeginAttrValue,nEndAttrValue,
					nNbMultipleSpaces))
		{
			char szString[MAX_PATH];
			strncpy(szString,szHtml+nBeginAttrName,nEndAttrName+1-nBeginAttrName);
			szString[nEndAttrName+1-nBeginAttrName]='\0';

			char szValue[2048];
			if (nBeginAttrValue<=nEndAttrValue)
			{
				strncpy(szValue,szHtml+nBeginAttrValue,nEndAttrValue+1-nBeginAttrValue);
				szValue[nEndAttrValue+1-nBeginAttrValue]='\0';
			}
			else // no real value
				szValue[0]='\0';

			RemoveQuotes(szValue);
			AddQuotes(szValue);

			char szOutput[2048];
			sprintf(szOutput,"Name=%s,Value=%s\n",szString,szValue);
//			ODS (szOutput);
//			cout << szOutput << endl;

			nBegin = nEndAttrValue+1;

			if (!bSeenTag)
				strcpy(szTagName,szString);

			// now repurpose the attribute values
			//
			//
			//

			
			if (stricmp(szString,"class")==0) // be sure to remove all CLASS attributes
			{
				szString[0]='\0';
			}
			else if (stricmp(szTagName,"a")==0) // Repurpose A tags
			{
				if (stricmp(szString,"href")==0)
				{
					if (strlen(szValue)>0)
					{
						RemoveQuotes(szValue);

						UINT nIndexSpace = -1;
						UINT i=0;
						while (i<strlen(szValue) && szValue[i]==' ')
						{
							i++;nIndexSpace++;
						}
						if (nIndexSpace>-1) // remove all spaces on the left
						{
							char szTemp[2048];
							strcpy(szTemp,szValue+nIndexSpace);
							strcpy(szValue,szTemp);
						}

						// process relative links only :
						// check out whether the link is relative or absolute
						char szTemp[2048];
						strcpy(szTemp,szValue);
						strlwr(szTemp);
						char *szHttpLink= strstr(szTemp,"http://");
						char *szFtpLink = strstr(szTemp,"ftp://");
						char *szMailLink= strstr(szTemp,"mailto:");
						char *szResLink = strstr(szTemp,"res://");
						char *szNewsLink= strstr(szTemp,"news://");
						char *szFileLink= strstr(szTemp,"file://");
						char *szJavascriptLink = strstr(szTemp,"javascript:");
						bool bNotToBeProcessed=(szHttpLink==szTemp || szFtpLink==szTemp || szMailLink==szTemp 
							|| szResLink==szTemp || szNewsLink==szTemp || szFileLink==szTemp || szJavascriptLink==szTemp);
						if (!bNotToBeProcessed) // probable process to perform
						{
							if (strlen(szBaseUrl)>0)
							{
								char szHostname[2048];
								char szCurrentDirectory[2048];

								char szNewValue[2048];
								if (szValue[0]=='/')
								{
									SplitBaseUrl(szBaseUrl,szHostname,szCurrentDirectory,false);
									// absolute link : use szHostname
									strcpy(szNewValue,szHostname); // add real domain (to ensure reach)
								}
								else
								{
									SplitBaseUrl(szBaseUrl,szHostname,szCurrentDirectory,true);
									// relative link : use szCurrentDirectory
									strcpy(szNewValue,szCurrentDirectory); // add current page hierarchy (to ensure reach)

								}

								strcat(szNewValue,szValue);
								strcpy(szValue,szNewValue);
							}
						}

						AddQuotes(szValue);
						
					} // end if strlen(szValue)>0
				} // end attribute=href
				else if (stricmp(szString,"target")==0) // force TARGET=_blank
				{
					strcpy(szValue,"\"_blank\"");
					bSeenTargetOnAnchor = true;
				}
			}
			else 
			{
				if (stricmp(szTagName,"img")==0  || // Delete IMG, B, I, U tags
					stricmp(szTagName,"/img")==0 || // Delete EM, CODE, FONT tags
					stricmp(szTagName,"b")==0    ||
					stricmp(szTagName,"/b")==0   ||
					stricmp(szTagName,"i")==0    ||
					stricmp(szTagName,"/i")==0   ||
					stricmp(szTagName,"u")==0    ||
					stricmp(szTagName,"/u")==0   ||
					stricmp(szTagName,"em")==0   ||
					stricmp(szTagName,"/em")==0  ||
					stricmp(szTagName,"code")==0 ||
					stricmp(szTagName,"/code")==0  ||
					stricmp(szTagName,"font")==0   ||
					stricmp(szTagName,"/font")==0  ||
					stricmp(szTagName,"br")==0     ||
					stricmp(szTagName,"/br")==0)
				bTagDesired = false;
			}




			// output the tag or current attribute
			//
			//
			//
			if (bTagDesired) // tag not to be deleted, then attributes ok to be output
			{
				if (!bSeenTag)
				{
					strcat(szOutputHtml,"<"); // output begin tags
					strcat(szOutputHtml,szTagName);
				}
				else
				{
					if (strlen(szString)>0) // output attributes according to allowance
					{
						strcat (szOutputHtml," ");
						strcat (szOutputHtml,szString);
						if (strlen(szValue)>0) 
						{
							strcat (szOutputHtml,"=");
							strcat (szOutputHtml,szValue);
						}
					}
				}
			}

			bSeenTag = true;

			

		} // end while next attribute


		if (bTagDesired)
		{
			// add target attribute to the anchor tag
			if ((stricmp(szTagName,"a")==0) && !bSeenTargetOnAnchor)
				strcat (szOutputHtml," target=\"_blank\"");

			// close the tag
			strcat(szOutputHtml,">");
		}


		nStart = nEnd+1;

	} // end while next tag

	if (nEnd<strlen(szHtml)) // output non-tag stuff
	{
		// copy the remainder of szHtml
		strcat(szOutputHtml,szHtml+nEnd+1);
	}

	// bounce back
	strcpy(szHtml,szOutputHtml);

}



//[IN] : szString : HTML content
//[IN] : szBeginString : where to start the search
//[OUT] : szBeginIndex : first '<'
//[OUT] : szEndIndex : first relevant '>'
bool HTMLParser::GetNextTag(char *szString, 
							UINT nBeginString, 
							UINT &nBeginIndex, 
							UINT &nEndIndex,
							UINT &nNbMultipleSpaces)
{
	bool bResult = false;

	// szString : -------+--------------------+-------------------+---
	//                 nBeginString
	//	                                  nBeginIndex         nEndIndex
	//
 
	nNbMultipleSpaces = 0;

	// avoid stupid things
	if (nBeginString>=strlen(szString))
		return bResult;

	// STEP 1. search for '<'

	nBeginIndex = nBeginString + strcspn(szString+nBeginString,"<");
	if (nBeginIndex==strlen(szString)) // not found
		return bResult;

	// STEP 2. go through all attributes
	UINT nBeginAttrName, nEndAttrName;
	UINT nBeginAttrValue, nEndAttrValue;

	UINT nBeginStringTemp = nBeginIndex+1; // pass the '<' char
	nEndAttrValue = nBeginStringTemp;
	if (nBeginStringTemp==strlen(szString)) // not found
		return bResult;
	if (szString[nBeginStringTemp]!='!' && szString[nBeginStringTemp]!='?') // <! or <?
	{
		// normal <...>
		while( GetNextAttribute(szString,nBeginStringTemp,
								nBeginIndex,-1,
								nBeginAttrName,nEndAttrName,
								nBeginAttrValue,nEndAttrValue,
								nNbMultipleSpaces) )
		{
			nBeginStringTemp = nEndAttrValue + 1;
		}
	}

	// STEP 3. search for '>'
	nEndIndex = strcspn(szString+nEndAttrValue+1,">");
	if (nEndIndex==strlen(szString)) // not found
		return bResult;

	nEndIndex += nEndAttrValue+1; // add offset

	return true;
}

//[IN] : szString : HTML content
//[IN] : nBeginString, where to start
//[IN] : nBeginIndex, first '<'
//[IN] : nEndIndex, first relevant '>' (pass -1 if not known)
//[OUT] : nBeginAttribute, start of the current attribute name
//[OUT] : nEndAttribute, end of the current attribute name
//[OUT] : nBeginValue, end of the current attribute value
//[OUT] : nEndValue, start of the current attribute value
bool HTMLParser::GetNextAttribute(char *szString,UINT nBeginString,
								 UINT nBeginIndex,UINT nEndIndex,
								 UINT &nBeginAttrName , UINT &nEndAttrName, 
								 UINT &nBeginAttrValue, UINT &nEndAttrValue,
								 UINT &nNbMultipleSpaces)
{
	bool bResult = false;

	UINT i = nBeginString;
	UINT nBegin = nBeginIndex;
	UINT nEnd = (nEndIndex==-1) ? strlen(szString) : nEndIndex ; 

	bool bFoundAttr = false;
	UINT nbSpaces = 0;
	// pass SPACES
	while (i>nBegin && i<nEnd && (szString[i]==' '))
	{
		i++; nbSpaces++;
	}
	if (nbSpaces>1)
		nNbMultipleSpaces += (nbSpaces-1);

	nBeginAttrName = i;

	// if we find a '>' char, there shouldn't be anything else interesting
	if (i>=nEnd || szString[i]=='>')
		return bResult;

	// pass ATTR
	while (i>nBegin && i<nEnd && (szString[i]!=' ') && (szString[i]!='=') && (szString[i]!='>'))
		i++;

	
	bResult = (i>nBeginAttrName);

	// 
	if (i<nEnd)
	{
		if (szString[i]==' ')
		{
			UINT iold = i; // keep copy of i

			nbSpaces = 0;
			// there may be a '=' char next to spaces
			while (i>nBegin && i<nEnd && (szString[i]==' '))
			{
				i++; nbSpaces++;
			}
			if (nbSpaces>1)
				nNbMultipleSpaces += (nbSpaces-1);


			if (i<nEnd)
			{
				if (szString[i]!='=')
				{
					nEndAttrName = nEndAttrValue =iold-1;
					nBeginAttrValue = nEndAttrValue+1; // special value (nBeginAttrValue>nEndAttrValue)
					return bResult;
				}
				else // found '='
				{
					nEndAttrName = i-1;

					nbSpaces = 0;
					// now pass SPACES until we find something else
					while (i>nBegin && i<nEnd && (szString[i]==' '))
					{
						i++; nbSpaces++;
					}
					if (nbSpaces>1)
						nNbMultipleSpaces += (nbSpaces-1);

				}
			}
			else
			{
				nEndAttrName = nBeginAttrValue = nEndAttrValue =i-1;
				return bResult;
			}
		}
		else if (szString[i]=='=')
		{
			nEndAttrName = i-1;
			i++;

			nbSpaces = 0;
			// now pass SPACES until we find something else
			while (i>nBegin && i<nEnd && (szString[i]==' '))
			{
				i++; nbSpaces++;
			}
			if (nbSpaces>1)
				nNbMultipleSpaces += (nbSpaces-1);

		}
		else if (szString[i]=='>')
		{
			nEndAttrName = i-1;
			nEndAttrValue =i-1;
			nBeginAttrValue = i; // special value (nBeginAttrValue>nEndAttrValue)
			return bResult;
		}

		nBeginAttrValue = nEndAttrValue =i; // default

		if (i<nEnd)
		{
			// now we are getting into the value itself
			// possible expressions are :
			// yrtiuytiueryti
			// 'yui yri uytiurtui'
			// "iyuiyuiy uiyui"
			if (szString[i]=='\'')
			{
				// go on until we find another '
				nBeginAttrValue = i;
				i++;
				while (i>nBegin && i<nEnd && (szString[i]!='\''))
					i++;
			}
			else if (szString[i]=='\"')
			{
				// go on until we find another "
				nBeginAttrValue = i;
				i++;
				while (i>nBegin && i<nEnd && (szString[i]!='\"'))
					i++;
			}
			else
			{
				while (i>nBegin && i<nEnd && (szString[i]!=' ') && (szString[i]!='>'))
					i++;

				i--;
			}

			nEndAttrValue = i;
		}
		else
			return bResult;
	}
	else // reached the end
	{
		nEndAttrName = i-1;
		nEndAttrValue =i-1;
		nBeginAttrValue = i; // special value (nBeginAttrValue>nEndAttrValue)
	}

	return bResult;
}






void HTMLParser::AddQuotes(char *szString)
{
	char szOutput[2048];
	// add ' or " depending on existing ' or " inside the string already
	if (strcspn(szString,"\"") < strlen(szString)) // found at least one "
	{
		// then add ' (to avoid internal conflicts)
		strcpy(szOutput,"\'");
		strcat(szOutput,szString);
		strcat(szOutput,"\'");
	}
	else
	{
		// else add "
		strcpy(szOutput,"\"");
		strcat(szOutput,szString);
		strcat(szOutput,"\"");
	}
	strcpy(szString,szOutput);
}



void HTMLParser::RemoveQuotes(char *szString)
{
	if (strlen(szString)==0)
		return;

	if ( (szString[0]=='\'') || (szString[0]=='\"') )
	{
		UINT nStart=1;
		UINT nEnd=strlen(szString)-1;

		if (nEnd>0)
		{
			if ( (szString[nEnd]=='\'') || (szString[nEnd]=='\"') )
				nEnd--;
		}

		char szOutput[2048]="\0";
		strncpy(szOutput,szString+nStart,nEnd+1-nStart);
		szOutput[nEnd+1-nStart]='\0';
		strcpy(szString,szOutput);
	}

}



// split the URL passed in szBaseUrl in as many portions as needed
// remember : a general URL is made of the following pieces 
// PROTOCOL   HOSTNAME        DIRECTORY   RESOURCE
// example :
// http://    www.wired.com   /news/      index.html
//
// thanks to server mapping, the following URL is also valid
// http://    www.wired.com
void HTMLParser::SplitBaseUrl(	char *szBaseUrl,
								char *szHostname,
								char *szCurrentDirectory,
								bool bNeedTrailingSlash)
{
	szHostname[0]='\0';
	szCurrentDirectory[0]='\0';

	if (strlen(szBaseUrl)==0)
		return;

	// find the PROTOCOL
	UINT nDoubleSlash = strcspn(szBaseUrl,"//");
	if (nDoubleSlash == strlen(szBaseUrl)) // not found
		return;

	// then find the first slash
	UINT nHostnameSlash = strcspn(szBaseUrl+nDoubleSlash+2,"//");
	nHostnameSlash += nDoubleSlash+2;
	if (nHostnameSlash==strlen(szBaseUrl)) // slash not found : simple URL of the form http://hostname
	{
		 strncpy(szHostname,szBaseUrl,nHostnameSlash);
		 szHostname[nHostnameSlash]='\0';
		 if (bNeedTrailingSlash)
			 strcat(szHostname,"/");
		 strcpy(szCurrentDirectory,szHostname);

		 return;
	}

	// the URL is in fact of the form http://hostname/...
	// let's find the last slash
	char *szLastSlash = strrchr(szBaseUrl,'/');
	UINT nLastSlash = szLastSlash-szBaseUrl;

	if (nLastSlash==nDoubleSlash || nLastSlash==nDoubleSlash+1)
		return; // something wrong went in the strrchr C-routine

	 strncpy(szHostname,szBaseUrl,nHostnameSlash);
	 szHostname[nHostnameSlash]='\0';
	 if (bNeedTrailingSlash)
		 strcat(szHostname,"/");

	 strncpy(szCurrentDirectory,szBaseUrl,nLastSlash);
	 szCurrentDirectory[nLastSlash]='\0';
	 if (bNeedTrailingSlash)
		 strcat(szCurrentDirectory,"/");
}

