
#include "stdafx.h"
#include "XmlFileManager.h"

CXmlFileManager *CXmlFileManager::chooseResourceManager(char *szURL)
{
	BOOL bInternetURL = (strlen(szURL)>7 && 
		( strnicmp(szURL,"http://",7)==0 || strnicmp(szURL,"ftp://",6)==0 ) );

	CXmlFileManager *pResourceManager = NULL;
	if (!bInternetURL)
		pResourceManager = new CXmlLocalFileManager();
	else
		pResourceManager = new CXmlInternetFileManager();

	if (!pResourceManager)
	{
		setLastError( SAXML_ERROR_OUTOFMEMORY );
		trace2(TRC_ERROR,"CXmlFileManager::chooseResourceManager",SAXML_ERRORSTRING_OUTOFMEMORY);
	}

	return pResourceManager;
}


long CXmlFileManager::m_nLastError;


CXmlFileManager::CXmlFileManager() 
{
	m_cnt = 0;
	skipNow(FALSE);
	setPromptMode(TRUE);
	SetMsgHandler(NULL);
	setParent(NULL);
}

CXmlFileManager::~CXmlFileManager() 
{
}

CXmlFileManager& CXmlFileManager::operator=(const CXmlFileManager &obj)
{
	// prohibited use
	return *this;
}


void  CXmlFileManager::setParent(void *pParent)
{
	m_cpParent = pParent;
}

void* CXmlFileManager::getParent()
{
	return m_cpParent;
}


BOOL CXmlFileManager::SetParamInt(int nParamID, int nValue)
{
	return TRUE;
}

BOOL CXmlFileManager::SetParamString(int nParamID, char *szValue)
{
	return TRUE;
}

BOOL CXmlFileManager::SetParamPtr(int nParamID, void *pValue)
{
	return TRUE;
}

int CXmlFileManager::GetParamInt(int nParamID)
{
	return 0;
}

char *CXmlFileManager::GetParamString(int nParamID)
{
	return NULL;
}

void *CXmlFileManager::GetParamPtr(int nParamID)
{
	return NULL;
}

void CXmlFileManager::SetMsgHandler(void *pHandler)
{
	m_cpHandler = pHandler;
}

void CXmlFileManager::peekMessage()
{
	// make sure that Windows is running smoothly by eating messages sent and received
	MSG msg ;
	if (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	{
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);

		if (msg.message==WM_KEYDOWN)
			if (msg.wParam==VK_ESCAPE) // escape process is the user presses the ESC key
				skipNow();
	}

}

void CXmlFileManager::setPromptMode(BOOL bPrompt)
{
	m_bPromptMode = bPrompt;
}

void CXmlFileManager::skipNow(BOOL bSkipNow) 
{ 
	m_bSkipNow = bSkipNow; 
}

BOOL CXmlFileManager::shouldSkipNow() 
{ 
	return m_bSkipNow; 
}


void CXmlFileManager::setLastError(long nError)
{
	m_nLastError = nError;
}


long CXmlFileManager::getLastError()
{ 
	return m_nLastError; 
}
