
#ifndef _SAXMLID_
#define _SAXMLID_

// element/attributes internal structure
#define SAXML_ATTRIBUTELEVEL			0
#define SAXML_ELEMENTLEVEL				1

#define SAXML_DATATYPE_STRING			0
#define SAXML_DATATYPE_NUMBER			1
#define SAXML_DATATYPE_FLOAT			2
#define SAXML_DATATYPE_DATE				3
#define SAXML_DATATYPE_TIME				4
#define SAXML_DATATYPE_CURRENCY			5
#define SAXML_DATATYPE_URL				6
#define SAXML_DATATYPE_EMAIL			7

#define SAXML_NOSORT					0
#define	SAXML_SORT_ASCENDING			1
#define SAXML_SORT_DESCENDING			2

#define SAXML_CONTENT_NO				0
#define SAXML_CONTENT_YES				1
#define SAXML_CONTENT_NOTAVAILABLE		2


// internal defines
#define SAXML_URLMAXLENGTH				2048
#define SAXML_BUFSIZE					1024
#define SAXML_MAXSAMPLEVALUES			20
#define SAXML_WINDOWSAMPLEVALUES		40
  
// 
#define SAXML_BLOCKSIZE					3000

// used by XmlFileManager
#define SAXML_PROXYHOSTNAME		0
#define SAXML_PROXYPORT			1

// messages sent between caller and callee
#define SAXML_MESSAGE_ASKCONTINUE		1


// errors
#define	SAXML_ERROR_OUTOFMEMORY							4000
#define	SAXML_ERROR_BADURL								4001
#define	SAXML_ERROR_WHILEPARSING						4002
#define	SAXML_ERROR_SAXCALLBACK							4003


// for DEBUG only in the log file (no need to localize)
#define	SAXML_ERRORSTRING_OUTOFMEMORY					"Out of memory"
#define	SAXML_ERRORSTRING_BADURL						"Bad URL"
#define	SAXML_ERRORSTRING_WHILEPARSING					"Error while parsing XML data"
#define	SAXML_ERRORSTRING_SAXCALLBACK					"Bad param in XML parse callback"

#endif