
#include "stdafx.h"
#include "XmlFileManager.h"

////////////////////////////////////////////////////////////////////////////////////////
//
//
// CXmlLocalFileManager class : access to a local XML resource
//
// local means FILE rather than STREAM file resource.
//
//
/////////////////////////////////////////////////////////////////////////////////////////
// Stephane Rodriguez, 1st july 2002
//
//
CXmlLocalFileManager::CXmlLocalFileManager()
{
	fp = NULL;
}
CXmlLocalFileManager::~CXmlLocalFileManager()
{
	Close();
}


CXmlLocalFileManager& CXmlLocalFileManager::operator=(const CXmlLocalFileManager &obj)
{
	// prohibited use
	return *this;
}


// Methods
//

BOOL CXmlLocalFileManager::Open(char *szURL)
{
	strcpy(m_szURL, szURL);

	// open descriptor file
	//
	fp=fopen(szURL,"rb"); // BINARY mode
	if (!fp)
	{
		char szMessage[SAXML_URLMAXLENGTH];
		sprintf(szMessage,"Can't open file %s\n",szURL);

		trace (TRC_ERROR,szMessage);

		setLastError( SAXML_ERROR_BADURL );
		trace2(TRC_ERROR,"CXmlLocalFileManager::Open\n",SAXML_ERRORSTRING_BADURL);

		return FALSE;
	}

	return TRUE;
}

BOOL CXmlLocalFileManager::Read(char *szInputBuffer, int nMaxLength, int &nActualLength)
{
	if (!fp)
	{
		setLastError( SAXML_ERROR_BADURL );
		trace2(TRC_ERROR,"CXmlLocalFileManager::Read",SAXML_ERRORSTRING_BADURL);

		return FALSE;
	}

	peekMessage();

	nActualLength = fread(szInputBuffer, 1, nMaxLength, fp);

	return TRUE;
}

BOOL CXmlLocalFileManager::Close()
{
	if (fp)
	{
		fclose(fp);
		fp=NULL;
	}

	return TRUE;
}
